Loading...
Searching...
No Matches
casacore::WCConcatenation Class Reference
images package (libcasa_images) » Regions_module

More...

`#include <WCConcatenation.h>`

## Public Member Functions

| WCConcatenation (const Block< const ImageRegion * > &regions, const WCBox &extendRange)
| Combine the given regions.
| WCConcatenation (Bool takeOver, const Block< const WCRegion * > &regions, const WCBox &extendRange)
| WCConcatenation (const WCConcatenation &other)
| Copy constructor (copy semantics).
virtual | ~WCConcatenation ()
WCConcatenation & | operator= (const WCConcatenation &other)
| Assignment (copy semantics).
virtual Bool | operator== (const WCRegion &other) const
| Comparison.
virtual WCRegion * | cloneRegion () const
| Make a copy of the derived object.
virtual String | type () const
| Get the region type.
virtual TableRecord | toRecord (const String &tableName) const
| Convert the (derived) object to a record.
Public Member Functions inherited from casacore::WCCompound
| WCCompound (const ImageRegion &region1, const ImageRegion &region2)
| Construct from one or more image regions.
| WCCompound (const ImageRegion *region1, const ImageRegion *region2=0, const ImageRegion *region3=0, const ImageRegion *region4=0, const ImageRegion *region5=0, const ImageRegion *region6=0, const ImageRegion *region7=0, const ImageRegion *region8=0, const ImageRegion *region9=0, const ImageRegion *region10=0)
| WCCompound (const Block< const ImageRegion * > &regions)
| WCCompound (Bool takeOver, const Block< const WCRegion * > &regions)
| Construct from multiple regions given as a Block.
| WCCompound (const WCCompound &other)
| Copy constructor (copy semantics).
virtual | ~WCCompound ()
const Block< const WCRegion * > & | regions () const
| Get the contributing regions.
Public Member Functions inherited from casacore::WCRegion
| WCRegion ()
| WCRegion (const WCRegion &other)
| Copy constructor (copy semantics).
virtual | ~WCRegion ()
| Destructor.
Bool | operator!= (const WCRegion &other) const
virtual uInt | ndim () const
| Get the dimensionality (i.e.
const Record & | getAxesDesc () const
| Get the description of all axes.
const Record & | getAxisDesc (uInt axis) const
| Get the description of the given axis.
Int | axisNr (const Record &desc, const Record &axesDesc) const
| Return the axis number of the description of an axis in the full axes description.
Bool | isAxisDescEqual (const Record &desc1, const Record &desc2) const
| Are both axis descriptions equal?
virtual Bool | canExtend () const
| Can the region extend itself?
const String & | comment () const
| Get or set the comment.
void | setComment (const String &comment)
virtual LCRegion * | toLCRegion (const CoordinateSystem &cSys, const IPosition &shape) const
| Convert to an LCRegion using the given new coordinate system and shape.
LCRegion * | toLCRegionAxes (const CoordinateSystem &cSys, const IPosition &shape, const IPosition &pixelAxesMap, const IPosition &outOrder) const
| Convert to an LCRegion using the given coordinate system and shape.
void | defineRecordFields (RecordInterface &record, const String &className) const
| Define the type and class name in the record.

## Static Public Member Functions

static String | className ()
| Get the class name (to store in the record).
static WCConcatenation * | fromRecord (const TableRecord &, const String &tableName)
| Convert correct object from a record.
Static Public Member Functions inherited from casacore::WCRegion
static WCRegion * | fromRecord (const TableRecord &rec, const String &tableName)
| Convert correct object from a record.

## Protected Member Functions

virtual LCRegion * | doToLCRegion (const CoordinateSystem &cSys, const IPosition &shape, const IPosition &pixelAxesMap, const IPosition &outOrder) const
| Convert to an LCRegion using the given coordinate system and shape.
Protected Member Functions inherited from casacore::WCCompound
WCCompound & | operator= (const WCCompound &other)
| Assignment (copy semantics) makes only sense for a derived class.
void | multiToLCRegion (Block< const LCRegion * > &regions, const CoordinateSystem &cSys, const IPosition &shape, const IPosition &pixelAxesMap, const IPosition &extendAxes) const
| Convert each WCRegion to an LCRegion.
TableRecord | makeRecord (const String &tableName) const
| Store the contributing regions in a record.
Protected Member Functions inherited from casacore::WCRegion
WCRegion & | operator= (const WCRegion &other)
| Assignment (copy semantics) makes only sense for a derived class.
void | addAxisDesc (const Record &axisDesc)
| Add an axis with its description.
Record | makeAxisDesc (const CoordinateSystem &cSys, uInt pixelAxis) const
| Make a description of a pixel axis in the coordinate system.
Record | makeAxesDesc (const CoordinateSystem &cSys) const
| Make a description of all pixel axes in the coordinate system (in pixel axes order).
void | makeWorldAbsolute (Vector< Double > &world, const Vector< Int > &absRel, const CoordinateSystem &cSys, const IPosition &shape) const
| Convert relative to absolute world as needed.
void | checkAxes (const IPosition &pixelAxes, const CoordinateSystem &cSys, const Vector< String > &quantityUnits) const

## Private Member Functions

void | fill ()
| Do a check and fill the remainder of the object.

## Private Attributes

WCBox | itsExtendBox

## Additional Inherited Members

Static Protected Member Functions inherited from casacore::WCCompound
static void | unmakeRecord (Block< const WCRegion * > &, const TableRecord &, const String &tableName)
| Retrieve the contributing objects from the record.
Static Protected Member Functions inherited from casacore::WCRegion
static void | unitInit ()
static void | convertPixel (Double &pixel, const Double &value, const String &unit, const Int absRel, const Double refPix, const Int shape)

## Detailed Description

Combine multiple ImageRegion's into a new dimension.

### Intended use:

Public interface

### Prerequisite

- WCCompound

### Synopsis

The WCConcatenation class is a specialization of class WCCompound. It makes it possible to combine multiple regions and to add a dimension on them. The axis and the range (beginning and end) of that new dimension have to be specified using an WCBox object. That axes should not be an axis in the given regions.

WCConcatenation can be seen as a mixture of the classes WCUnion and WCExtension. Like WCUnion it combines regions and like WCExtension it increases the dimensionality for the new region (be it with only 1).
Unlike WCUnion the axes have to be the same in all regions, because creating a WCConcatenation means combining similar regions.

E.g. One can define a different polygon in the RA-DEC plane of each channel. WCConcatenation makes it possible to combine the polygons to one 3D region in the RA-DEC-Freq cube.

### Example

This example combines n (relative) circles given in the RA,DEC plane along the FREQ-axis. In this example the regions used are circles with the same centers, but it is also possible to combine differently shaped regions. Note that WCConcatenation takes over the pointers to the individual regions, so they do not need to be deleted (the WCConcatenation destructor does it).

IPosition center (2,10,20);
Block<ImageRegion*> cirPtr(n);
for (i=0; i<n; i++) {
// Each circle has a different radius.
cirPtr(i) = new WCEllipsoid cir1 (center, 1 + i%(n/2));
}
// Construct the concatenation for a range (given as a box in fractions).
// Extend along the FREQ-axis (the 2nd axis in the given cSys).\.
// Take over the region pointers.
Vector<Quantity> blc(1);
Vector<Quantity> trc(1);
blc(0) = Quantity (0.25, "frac");
trc(0) = Quantity (0.75, "frac");
WCConcatenation region (True, cirPtr, WCBox(blc, trc, cSys, IPosition(1,2));
casacore::Block
Definition Block.h:140
casacore::IPosition
Definition IPosition.h:117
casacore::Vector
Definition Vector.h:82
casacore::WCBox
Definition WCBox.h:292
casacore::WCConcatenation
Definition WCConcatenation.h:108
casacore::WCEllipsoid
Definition WCEllipsoid.h:70
casacore::Quantity
Quantum< Double > Quantity
Definition Quantum.h:39
casacore::True
const Bool True
Definition aipstype.h:41

This example is artificial in the sense that WCEllipsoid does not exist yet and the WCBox constructor looks a bit different. One should probably also do a bit more trouble to find out if FREQ is indeed the 2nd axis in the coordinate system.

Definition at line 107 of file WCConcatenation.h.

## Constructor & Destructor Documentation

## WCConcatenation() [1/3]

casacore::WCConcatenation::WCConcatenation | ( | const Block< const ImageRegion * > & | regions,
|  | const WCBox & | extendRange )

Combine the given regions.

When takeOver is True, the destructor will delete the given regions. Otherwise a copy of the regions is made. The extend range has to be given as a 1-dimensional box.

References casacore::WCCompound::regions().

Referenced by fromRecord(), operator=(), and WCConcatenation().

## WCConcatenation() [2/3]

casacore::WCConcatenation::WCConcatenation | ( | Bool | takeOver,
|  | const Block< const WCRegion * > & | regions,
|  | const WCBox & | extendRange )

References casacore::WCCompound::regions().

## WCConcatenation() [3/3]

casacore::WCConcatenation::WCConcatenation | ( | const WCConcatenation & | other | ) |

Copy constructor (copy semantics).

References WCConcatenation().

## ~WCConcatenation()

virtual casacore::WCConcatenation::~WCConcatenation | ( |  | ) |

virtual

## Member Function Documentation

## className()

String casacore::WCConcatenation::className | ( |  | ) |

static

Get the class name (to store in the record).

## cloneRegion()

virtual WCRegion * casacore::WCConcatenation::cloneRegion | ( |  | ) | const

virtual

Make a copy of the derived object.

Implements casacore::WCRegion.

## doToLCRegion()

virtual LCRegion * casacore::WCConcatenation::doToLCRegion | ( | const CoordinateSystem & | cSys,
|  | const IPosition & | shape,
|  | const IPosition & | pixelAxesMap,
|  | const IPosition & | outOrder ) const

protected virtual

Convert to an LCRegion using the given coordinate system and shape.

pixelAxesMap(i) gives the pixel axis in cSys of axes i in the axesDesc.

Implements casacore::WCRegion.

References casacore::shape().

## fill()

void casacore::WCConcatenation::fill | ( |  | ) |

private

Do a check and fill the remainder of the object.

## fromRecord()

WCConcatenation * casacore::WCConcatenation::fromRecord | ( | const TableRecord & | ,
|  | const String & | tableName )

static

Convert correct object from a record.

References WCConcatenation().

## operator=()

WCConcatenation & casacore::WCConcatenation::operator= | ( | const WCConcatenation & | other | ) |

Assignment (copy semantics).

References WCConcatenation().

## operator==()

virtual Bool casacore::WCConcatenation::operator== | ( | const WCRegion & | other | ) | const

virtual

Comparison.

Reimplemented from casacore::WCCompound.

## toRecord()

virtual TableRecord casacore::WCConcatenation::toRecord | ( | const String & | tableName | ) | const

virtual

Convert the (derived) object to a record.

Implements casacore::WCRegion.

## type()

virtual String casacore::WCConcatenation::type | ( |  | ) | const

virtual

Get the region type.

Returns className()

Implements casacore::WCRegion.

## Member Data Documentation

## itsExtendBox

WCBox casacore::WCConcatenation::itsExtendBox

private

Definition at line 162 of file WCConcatenation.h.

The documentation for this class was generated from the following file:

- images/Regions/WCConcatenation.h